From: Matthias Klose <doko@ubuntu.com>
Date: Wed, 28 Oct 2015 16:09:31 +0100
Subject: Build using giflib5

Forwarded: no
---
 codecs/gif.cc | 73 +++++++++++++++++++++++++++++++++++++++++++++++++++--------
 1 file changed, 63 insertions(+), 10 deletions(-)

diff --git a/codecs/gif.cc b/codecs/gif.cc
index f670619..183c5d3 100644
--- a/codecs/gif.cc
+++ b/codecs/gif.cc
@@ -17,6 +17,12 @@
 
 #include <gif_lib.h>
 
+#if (GIFLIB_MAJOR > 5) || (GIFLIB_MAJOR == 5 && GIFLIB_MINOR >= 1)
+#define Internal_EGifCloseFile(f) EGifCloseFile(f, NULL)
+#else
+#define Internal_EGifCloseFile(f) EGifCloseFile(f)
+#endif
+
 #include "gif.hh"
 #include "Colorspace.hh"
 
@@ -57,12 +63,20 @@ int GIFCodec::readImage (std::istream* stream, Image& image, const std::string&
   GifFileType* GifFile;
   GifRecordType RecordType;
   GifByteType* Extension;
-  ColorMapObject *ColorMap = 0;
+  ColorMapObject *ColorMap = NULL;
   int GifError, ExtCode;
   
-  if ((GifFile = DGifOpen (stream, &GIFInputFunc, &GifError)) == 0)
+#if (GIFLIB_MAJOR > 5) || (GIFLIB_MAJOR == 5 && GIFLIB_MINOR >= 1)
+  if ((GifFile = DGifOpen (stream, &GIFInputFunc, &GifError)) == NULL)
+#else
+  if ((GifFile = DGifOpen (stream, &GIFInputFunc)) == NULL)
+#endif
     {
+#if (GIFLIB_MAJOR > 5) || (GIFLIB_MAJOR == 5 && GIFLIB_MINOR >= 1)
+      //std::cerr << "Error: " << GifErrorString(GifError) << std::endl;
+#else
       //PrintGifError();
+#endif
       return false;
     }
   
@@ -74,7 +88,11 @@ int GIFCodec::readImage (std::istream* stream, Image& image, const std::string&
   /* Scan the content of the GIF file and load the image(s) in: */
   do {
     if (DGifGetRecordType(GifFile, &RecordType) == GIF_ERROR) {
+#if (GIFLIB_MAJOR > 5) || (GIFLIB_MAJOR == 5 && GIFLIB_MINOR >= 1)
+      //std::cerr << "DGifGetRecordType error: " << GifErrorString(GifFile->Error) << std::endl;
+#else
       //PrintGifError();
+#endif
       return false;
     }
     
@@ -83,7 +101,11 @@ int GIFCodec::readImage (std::istream* stream, Image& image, const std::string&
     switch (RecordType) {
     case IMAGE_DESC_RECORD_TYPE:
       if (DGifGetImageDesc(GifFile) == GIF_ERROR) {
-	//PrintGifError();
+#if (GIFLIB_MAJOR > 5) || (GIFLIB_MAJOR == 5 && GIFLIB_MINOR >= 1)
+        //std::cerr << "DGifGetImageDesc error: " << GifErrorString(GifFile->Error) << std::endl;
+#else
+        //PrintGifError();
+#endif
 	return false;
       }
       
@@ -104,7 +126,11 @@ int GIFCodec::readImage (std::istream* stream, Image& image, const std::string&
 	       j += InterlacedJumps[i]) {
 	    if (DGifGetLine(GifFile, &image.getRawData()[j*image.stride()+Col],
 			    Width) == GIF_ERROR) {
+#if (GIFLIB_MAJOR > 5) || (GIFLIB_MAJOR == 5 && GIFLIB_MINOR >= 1)
+	      //std::cerr << "DGifGetLine error: " << GifErrorString(GifFile->Error) << std::endl;
+#else
 	      //PrintGifError();
+#endif
 	      return false;
 	    }
 	  }
@@ -113,7 +139,11 @@ int GIFCodec::readImage (std::istream* stream, Image& image, const std::string&
 	for (int i = 0; i < Height; ++i) {
 	  if (DGifGetLine(GifFile, &image.getRawData()[Row++ * image.stride()+Col],
 			  Width) == GIF_ERROR) {
+#if (GIFLIB_MAJOR > 5) || (GIFLIB_MAJOR == 5 && GIFLIB_MINOR >= 1)
+	    //std::cerr << "DGifGetLine error: " << GifErrorString(GifFile->Error) << std::endl;
+#else
 	    //PrintGifError();
+#endif
 	    return false;
 	  }
 	}
@@ -122,12 +152,20 @@ int GIFCodec::readImage (std::istream* stream, Image& image, const std::string&
     case EXTENSION_RECORD_TYPE:
       /* Skip any extension blocks in file: */
       if (DGifGetExtension(GifFile, &ExtCode, &Extension) == GIF_ERROR) {
+#if (GIFLIB_MAJOR > 5) || (GIFLIB_MAJOR == 5 && GIFLIB_MINOR >= 1)
+	//std::cerr << "DGifGetExtension error: " << GifErrorString(GifFile->Error) << std::endl;
+#else
 	//PrintGifError();
+#endif
 	return false;
       }
       while (Extension != 0) {
 	if (DGifGetExtensionNext(GifFile, &Extension) == GIF_ERROR) {
+#if (GIFLIB_MAJOR > 5) || (GIFLIB_MAJOR == 5 && GIFLIB_MINOR >= 1)
+	  //std::cerr << "DGifGetExtensionNext error: " << GifErrorString(GifFile->Error) << std::endl;
+#else
 	  //PrintGifError();
+#endif
 	  return false;
 	}
       }
@@ -155,7 +193,7 @@ int GIFCodec::readImage (std::istream* stream, Image& image, const std::string&
   // convert colormap to our 16bit "TIFF"format
   colorspace_de_palette (image, ColorMap->ColorCount, rmap, gmap, bmap);
   
-  EGifCloseFile(GifFile, &GifError);
+  Internal_EGifCloseFile(GifFile);
 
   return true;
 }
@@ -166,17 +204,29 @@ bool GIFCodec::writeImage (std::ostream* stream, Image& image, int quality,
   GifFileType* GifFile;
   GifByteType* Ptr;
   int GifError;
-  
-  if ((GifFile = EGifOpen(stream, &GIFOutputFunc, &GifError)) == 0)
+
+#if (GIFLIB_MAJOR > 5) || (GIFLIB_MAJOR == 5 && GIFLIB_MINOR >= 1)
+  if ((GifFile = EGifOpen (stream, &GIFOutputFunc, &GifError)) == NULL)
+#else
+  if ((GifFile = EGifOpen (stream, &GIFOutputFunc)) == NULL)
+#endif
     {
+#if (GIFLIB_MAJOR > 5) || (GIFLIB_MAJOR == 5 && GIFLIB_MINOR >= 1)
+      std::cerr << "Error preparing GIF file for writing: " << GifErrorString(GifError) << std::endl;
+#else
       std::cerr << "Error preparing GIF file for writing." << std::endl;
+#endif
       return false;
     }
   
   int ColorMapSize = 256;
   
   // later use our own colormap generation
-  ColorMapObject* OutputColorMap = GifMakeMapObject(ColorMapSize, 0);
+#if (GIFLIB_MAJOR > 5) || (GIFLIB_MAJOR == 5 && GIFLIB_MINOR >= 1)
+  ColorMapObject* OutputColorMap = GifMakeMapObject(ColorMapSize, NULL);
+#else
+  ColorMapObject* OutputColorMap = MakeMapObject(ColorMapSize, NULL);
+#endif
   if (!OutputColorMap)
     return false;
   
@@ -203,8 +253,11 @@ bool GIFCodec::writeImage (std::ostream* stream, Image& image, int quality,
     *bptr++ = b;
   }
    
-  
+#if (GIFLIB_MAJOR > 5) || (GIFLIB_MAJOR == 5 && GIFLIB_MINOR >= 1)
   if (GifQuantizeBuffer(image.w, image.h, &ColorMapSize,
+#else
+  if (QuantizeBuffer(image.w, image.h, &ColorMapSize,
+#endif
 		     RedBuffer, GreenBuffer, BlueBuffer,
 		     OutputBuffer, OutputColorMap->Colors) == GIF_ERROR) {
     return false;
@@ -216,7 +269,7 @@ bool GIFCodec::writeImage (std::ostream* stream, Image& image, int quality,
   if (EGifPutScreenDesc(GifFile, image.w, image.h,
 			ColorMapSize, 0, OutputColorMap) == GIF_ERROR ||
       EGifPutImageDesc(GifFile, 0, 0, image.w, image.h,
-		       false, 0) == GIF_ERROR)
+		       false, NULL) == GIF_ERROR)
     {
       std::cerr << "Error writing GIF header." << std::endl;
       return false;
@@ -235,7 +288,7 @@ bool GIFCodec::writeImage (std::ostream* stream, Image& image, int quality,
 
   delete[] RedBuffer; delete[] GreenBuffer; delete[] BlueBuffer;
 
-  EGifCloseFile(GifFile, &GifError);
+  Internal_EGifCloseFile(GifFile);
   return true;
 }
 
